//LEVEL DEFINITION
var Level01 = new Map();


Level01.materials = new Array();
//Floor
Level01.materials[0] = new THREE.MeshPhongMaterial(
	{
		ambient: 0xffffff,
		color: 0xffffff,
		specular: 0xffffff,
	});

//Walls
Level01.materials[1] = new THREE.MeshPhongMaterial(
	{
		ambient: 0xD0D0D0,
		color: 0xD0D0D0,
		specular: 0xD0D0D0,
	});
// Potato
Level01.materials[2] = new THREE.MeshPhongMaterial(
	{
		ambient: 0xB09A46,
		color: 0xB09A46,
		specular: 0xB09A46,
	});
//Lights
Level01.lights = 
{
20 : new THREE.DirectionalLight( 0xffffff, 0 ),
}

//Particles
Level01.particles =
{
	30: new ParticleSystem(),
}

Level01.lights[20].position.y = 60;
Level01.lights[20].updateMatrixWorld();

Level01.layout =  new Array();
Level01.layout.push([,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]);
Level01.layout.push([,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1]);
Level01.layout.push([,1,0,1,0,1,1,0,1,1,1,0,1,0,1,0,1,1,1,1,0,1,0,1]);
Level01.layout.push([,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1]);
Level01.layout.push([,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,1,0,0,0,1]);
Level01.layout.push([,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1]);
Level01.layout.push([,1,9,0,1,0,0,0,0,0,0,20,0,0,0,0,0,0,0,1,0,0,9,1]);
Level01.layout.push([,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1]);
Level01.layout.push([,1,0,0,0,0,0,1,1,0,0,0,0,0,1,1,0,0,0,1,0,0,0,1]);
Level01.layout.push([,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1]);
Level01.layout.push([,1,0,1,0,1,1,0,1,1,1,0,1,0,1,1,1,0,1,1,0,1,0,1]);
Level01.layout.push([,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1]);
Level01.layout.push([,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]);

// Ambient effects
Level01.AmbientEffects = 
[
	function()
	{
		this.tick = function()
		{
			Level01.lights[20].intensity = Math.random();
			this.passed++;
			if (this.passed == 7)
			{
				window.clearInterval(this.interval);
				Level01.lights[20].intensity = 0;
			}
		}
		
		this.passed = 0;
		this.interval = window.setInterval((function(self) { return function() { self.tick(); }})(this), 100);
	},
]

