
var Application = {
	// Window
	Width :  window.innerWidth,
	Height : window.innerHeight,
	Aspect  : (window.innerWidth) / (window.innerHeight),
	
	
	Views : 
	[
		{
			x : 0,
			y : 0,
			width : 800,
			height : 350,
			
			aspect : 800/350,
			camera : null,
		},
		{
			x : 0,
			y : 400,
			width : 800,
			height : 350,
			
			aspect : 800/350,
			camera : null,
		},
		//{
		//	x : 0,
		//	y : 300,
		//	width : 400,
		//	height : 150,
		//	
		//	aspect : 400/150,
		//	camera : null,
		//}
	],
	
	// Camera
	// very bad clipping planes
	NearClip : 0.1,
	FarClip : 10000,
	FieldOfView : 60,
	Overview : null,
	
	Renderer : null,	
	Scene : null,
	
	
	
	InputHandler : null,
	
	// Holds all game entities, have to implement Update function.
	Entities : new Array(),
	InteractiveObjects : null,
	
	// Initialize
	run : function()
	{
		this.initInputHandler();
		this.initRenderer();
		this.initCamera();
		this.initScene();
		
		document.getElementById("jsapp").appendChild(this.Renderer.domElement);
		
		this.setupWorld(Level01);
		
		//start render loop
		this.animate();
		
		// start game loop
		this.initGameLoop();
		
	},
	
	initPhysiJS : function()
	{
			Physijs.scripts.worker = 'lib/physijs_worker.js';
			Physijs.scripts.ammo = 'lib/ammo.js';
	},
	
	initInputHandler : function()
	{
		// only dom element: window Works
		var inputHandler =  new InputHandler();
		window.onkeydown = function(event) { inputHandler.KeyDown(event); }
		window.onkeyup = function(event) { inputHandler.KeyUp(event); }
		this.InputHandler = inputHandler;
	},
	
	initRenderer : function()
	{
		this.Renderer = new  THREE.WebGLRenderer({antialias: true});
		this.Renderer.setSize(800, 750);
		this.Renderer.setClearColor(0x000000, 1);
		//this.Renderer.autoClear = true;
		//this.Renderer.shadowMapEnabled = true;
	},
	
	initCamera : function()
	{
		//this.Views[2].camera = new THREE.PerspectiveCamera( 45, this.Views[2].aspect, 1, 1000 );
		//this.Views[2].camera.up = new THREE.Vector3(0,0,-1);
	},
	
	initScene : function()
	{
		//this.Scene = new THREE.Scene();
		this.Scene = new Physijs.Scene();
	},
	
	initGameLoop : function()
	{
		window.setInterval(Application.update, 1000/50);
	},
	
	
	// /Initialize
	 
	// Setup game
	setupWorld : function(level)
	{
		var level = level;
		level.parse();
		for (var i = 0; i < level.worldObjects.length; i++)
		{
			this.Scene.add(level.worldObjects[i]);
		}
		
		this.InteractiveObjects = level.InteractiveObjects;
		
		this.setupPlayer(Player1, level.playerPositions[0], 0);
		this.setupPlayer(Player2, level.playerPositions[1], 1);
		
		//this.Views[2].camera.position = new THREE.Vector3(level.Width/2, 25, level.Height/2)
		//this.Views[2].camera.lookAt(new THREE.Vector3(level.Width/2, 0, level.Height/2));
		
		Player1.opponent = Player2;
		Player2.opponent = Player1;
		
		this.Entities.push(new Ambiance());
	},
	
	setupPlayer : function(player, position, index)
	{
		player.Object3D.position = position
		
		player.Camera = new THREE.PerspectiveCamera(this.FieldOfView, this.Aspect, 0.1, 10000)
		player.Camera.Up = new THREE.Vector3(0,1,0);
		
		var mover = new MovementControllers[index](this.InputHandler, player.Object3D);
		var camFollower = new ObjectFollower(player.Object3D, player.Camera, new THREE.Vector3(0,0,0));
		var flashlight = new ObjectFollower(player.Object3D, player.Light, new THREE.Vector3(0,-2,0));
		var flashlightTarget = new ObjectFollower(player.Object3D, player.LightTarget, new THREE.Vector3(0,3,3));
		
		player.AddToScene(this.Scene);
		this.Views[index].camera = player.Camera;
		
		player.Object3D.setDamping(0.99,1);

		this.Entities.push(mover);
		this.Entities.push(camFollower);
		this.Entities.push(flashlight);
		this.Entities.push(flashlightTarget);
		this.Entities.push(player);
		this.Entities.push(player.Shader);
	},
	
	// Render loop
	animate : function()
	{
		requestAnimationFrame(Application.animate);
		
		Application.renderScene();
	},
	
	// Game Loop
	update : function()
	{
		for (var i = 0; i < Application.Entities.length; i++)
		{
			Application.Entities[i].Update(Application.InteractiveObjects);
		}
		
		Application.Scene.simulate();
	},
	
	renderScene : function()
	{
		for (var i = 0; i < this.Views.length; i++)
		{
			//this.Views[i].camera.aspect = this.Views[i].aspect;
			this.Renderer.setViewport(this.Views[i].x, this.Views[i].y, this.Views[i].width, this.Views[i].height);
			this.Renderer.setScissor(this.Views[i].x, this.Views[i].y, this.Views[i].width, this.Views[i].height);
			this.Renderer.enableScissorTest(true);
			this.Renderer.render(this.Scene, this.Views[i].camera);
		}
	},
}

// boot
window.onload = Application.run();

