var playerMaterial = Physijs.createMaterial(new THREE.MeshLambertMaterial({ color: 0x568D52 }), 1, 0);
var Player2 = null;

var Player1 = new Character(new Physijs.BoxMesh(new THREE.SphereGeometry(0.25,20,20), playerMaterial));
Player1.Shader = new PlayerShaderContainer(Player1.Object3D);

Player1.LightTarget = new THREE.Object3D();
Player1.Light =  new THREE.SpotLight( 0xffffff, 0.8 );

Player1.Light.shadowCameraNear = 1;
Player1.Light.shadowCameraFar = 5;
Player1.Light.shadowCameraFov = 30;
Player1.Light.shadowCameraVisible = true;
Player1.Light.target = Player1.LightTarget;
Player1.Light.shadowBias = -0.00022;
Player1.Light.shadowDarkness = 0.5;
Player1.lightOff = false;
Player1.isCop = true;


Player1.Update = function(interactiveObjects)
{
	// Flicker flashlight
	var rand = Math.random();
	if (rand > 0.5 && rand < 0.6)
	{
		Player1.Light.intensity = rand;
	}
}

Player1.onCollision = function(collided_with, linearVelocity, angularVelocity)
{
	if (collided_with == Player1.opponent.Object3D)
	{
		if (Player1.isCop)
		{
			Player1.opponent.isCop = true;
			Player1.isCop = false;
			new Hud().SetPlayer1Msg("Run! Run!");
			new Hud().SetPlayer2Msg("Gotta catch em all!")
			new Audio().PlayPlayer2();
		} 
		else
		{
			Player1.opponent.isCop = false;
			Player1.isCop = true;
			new Hud().SetPlayer2Msg("Run! Run!");
			new Hud().SetPlayer1Msg("Gotta catch em all!")
			new Audio().PlayPlayer1();
		}
	}
}
Player1.Object3D.addEventListener('collision', Player1.onCollision);
Player1.AddToScene = function(scene)
{
	scene.add(Player1.Light);
	scene.add(Player1.Object3D);
	scene.add(Player1.Camera);
	
	Player1.Object3D.setLinearFactor(new THREE.Vector3(1,0,1));
	Player1.Object3D.setAngularFactor(new THREE.Vector3(0,1,0));
	
}




var Player2 = new Character(new Physijs.BoxMesh(new THREE.SphereGeometry(0.25,20,20), playerMaterial));
Player2.Shader = new PlayerShaderContainer(Player2.Object3D);

Player2.LightTarget = new THREE.Object3D();
Player2.Light =  new THREE.SpotLight( 0xffffff, 0.8 );
      
Player2.Light.shadowCameraNear = 1;
Player2.Light.shadowCameraFar = 5;
Player2.Light.shadowCameraFov = 30;
Player2.Light.target = Player2.LightTarget;
Player2.Light.shadowBias = -0.00022;
Player2.Light.shadowDarkness = 0.5;
Player2.isCop = false;
Player2.opponent = Player1;


Player2.Update = function(interactiveObjects)
{
	// Flicker flashlight
	var rand = Math.random();
	if (rand > 0.5 && rand < 0.6)
	{
		Player2.Light.intensity = rand;
	}
}

Player2.AddToScene = function(scene)
{
	scene.add(Player2.Light);
	scene.add(Player2.Object3D);
	scene.add(Player2.Camera);
	
	Player2.Object3D.setLinearFactor(new THREE.Vector3(1,0,1));
	Player2.Object3D.setAngularFactor(new THREE.Vector3(0,1,0));
}

